Index: usr.bin/xlint/lint2/emit2.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/emit2.c,v
retrieving revision 1.5
diff -u -r1.5 emit2.c
--- usr.bin/xlint/lint2/emit2.c	7 Jul 2004 12:13:26 -0000	1.5
+++ usr.bin/xlint/lint2/emit2.c	25 Dec 2006 10:34:34 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: emit2.c,v 1.5 2005/11/20 17:09:55 cloder Exp $	*/
 /*	$NetBSD: emit2.c,v 1.2 1995/07/03 21:24:44 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: emit2.c,v 1.2 1995/07/03 21:24:44 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint2/emit2.c,v 1.5 2004/07/07 12:13:26 asmodai Exp $
  */
 
@@ -186,7 +186,7 @@
 
 	/*
 	 * If there is a definition, write it. Otherwise write a tentative
-	 * definition. This is neccessary because more than one tentative
+	 * definition. This is necessary because more than one tentative
 	 * definition is allowed (except with sflag).
 	 */
 	def = NULL;
Index: usr.bin/xlint/lint2/externs2.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/externs2.h,v
retrieving revision 1.3
diff -u -r1.3 externs2.h
--- usr.bin/xlint/lint2/externs2.h	3 Nov 2003 19:31:34 -0000	1.3
+++ usr.bin/xlint/lint2/externs2.h	25 Dec 2006 10:35:04 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: externs2.h,v 1.6 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: externs2.h,v 1.2 1995/07/03 21:24:46 cgd Exp $	*/
 
 /*
@@ -42,7 +43,6 @@
 extern	const	char *libname;
 extern	int	pflag;
 extern	int	sflag;
-extern	int	tflag;
 extern	int	Hflag;
 extern	int	hflag;
 extern	int	Fflag;
@@ -60,6 +60,7 @@
  */
 extern	const	char **fnames;
 extern	type_t	**tlst;
+extern	int	csrcfile;
 
 extern	void	readfile(const char *);
 extern	void	mkstatic(hte_t *);
Index: usr.bin/xlint/lint2/hash.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/hash.c,v
retrieving revision 1.5
diff -u -r1.5 hash.c
--- usr.bin/xlint/lint2/hash.c	7 Jul 2004 12:13:26 -0000	1.5
+++ usr.bin/xlint/lint2/hash.c	25 Dec 2006 10:35:45 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: hash.c,v 1.5 2005/11/20 17:09:55 cloder Exp $	*/
 /*	$NetBSD: hash.c,v 1.2 1995/07/03 21:24:47 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: hash.c,v 1.2 1995/07/03 21:24:47 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint2/hash.c,v 1.5 2004/07/07 12:13:26 asmodai Exp $
  */
 
@@ -92,6 +92,7 @@
 
 	/* create a new hte */
 	hte = xalloc(sizeof (hte_t));
+	memset(hte, 0, sizeof (hte_t));
 	hte->h_name = xstrdup(s);
 	hte->h_lsym = &hte->h_syms;
 	hte->h_lcall = &hte->h_calls;
Index: usr.bin/xlint/lint2/main2.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/main2.c,v
retrieving revision 1.6
diff -u -r1.6 main2.c
--- usr.bin/xlint/lint2/main2.c	7 Jul 2004 12:24:01 -0000	1.6
+++ usr.bin/xlint/lint2/main2.c	25 Dec 2006 10:37:56 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: main2.c,v 1.9 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: main2.c,v 1.2 1995/07/03 21:24:53 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: main2.c,v 1.2 1995/07/03 21:24:53 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint2/main2.c,v 1.6 2004/07/07 12:24:01 asmodai Exp $
  */
 
@@ -57,13 +57,11 @@
 int	pflag;
 
 /*
- * warnings for (tentative) definitions of the same name in more then
+ * warnings for (tentative) definitions of the same name in more than
  * one translation unit
  */
 int	sflag;
 
-int	tflag;
-
 /*
  * If a complaint stems from a included file, print the name of the included
  * file instead of the name spezified at the command line followed by '?'
@@ -73,7 +71,7 @@
 int	hflag;
 
 /* Print full path names, not only the last component */
-int	Fflag;
+int	Fflag = 1;
 
 /*
  * List of libraries (from -l flag). These libraries are read after all
@@ -100,9 +98,6 @@
 		case 's':
 			sflag = 1;
 			break;
-		case 't':
-			tflag = 1;
-			break;
 		case 'u':
 			uflag = 0;
 			break;
@@ -115,7 +110,7 @@
 		case 'C':
 			len = strlen(optarg);
 			lname = xmalloc(len + 10);
-			(void)sprintf(lname, "llib-l%s.ln", optarg);
+			(void)snprintf(lname, len + 10, "llib-l%s.ln", optarg);
 			libname = lname;
 			Cflag = 1;
 			uflag = 0;
Index: usr.bin/xlint/lint2/mem2.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/mem2.c,v
retrieving revision 1.3
diff -u -r1.3 mem2.c
--- usr.bin/xlint/lint2/mem2.c	7 Jul 2004 12:13:26 -0000	1.3
+++ usr.bin/xlint/lint2/mem2.c	25 Dec 2006 10:38:29 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: mem2.c,v 1.4 2005/11/20 17:09:55 cloder Exp $	*/
 /*	$NetBSD: mem2.c,v 1.3 1995/10/02 17:27:11 jpo Exp $	*/
 
 /*
@@ -79,7 +80,7 @@
 		prot = PROT_READ | PROT_WRITE;
 		flags = MAP_ANON | MAP_PRIVATE;
 		mbuf = mmap(NULL, mblklen, prot, flags, -1, (off_t)0);
-		if (mbuf == (void *)MAP_FAILED)
+		if (mbuf == MAP_FAILED)
 			err(1, "can't map memory");
 		if (ALIGN((u_long)mbuf) != (u_long)mbuf)
 			errx(1, "mapped address is not aligned");
Index: usr.bin/xlint/lint2/msg.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/msg.c,v
retrieving revision 1.7
diff -u -r1.7 msg.c
--- usr.bin/xlint/lint2/msg.c	7 Jul 2004 12:24:01 -0000	1.7
+++ usr.bin/xlint/lint2/msg.c	25 Dec 2006 10:39:35 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: msg.c,v 1.8 2005/12/10 20:26:10 cloder Exp $	*/
 /*	$NetBSD: msg.c,v 1.2 1995/07/03 21:24:56 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: msg.c,v 1.2 1995/07/03 21:24:56 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint2/msg.c,v 1.7 2004/07/07 12:24:01 asmodai Exp $
  */
 
@@ -43,27 +43,27 @@
 
 
 static	const	char *msgs[] = {
-	"%s used( %s ), but not defined",			      /* 0 */
-	"%s defined( %s ), but never used",			      /* 1 */
-	"%s declared( %s ), but never used or defined",		      /* 2 */
-	"%s multiply defined  \t%s  ::  %s",			      /* 3 */
-	"%s value used inconsistently  \t%s  ::  %s",		      /* 4 */
-	"%s value declared inconsistently  \t%s  ::  %s",	      /* 5 */
-	"%s, arg %d used inconsistently  \t%s  ::  %s",		      /* 6 */
-	"%s: variable # of args  \t%s  ::  %s",			      /* 7 */
+	"%s: %s used, but not defined",				      /* 0 */
+	"%s: %s defined, but never used",			      /* 1 */
+	"%s: %s declared, but never used or defined",		      /* 2 */
+	"%s: %s multiply defined (%s)",				      /* 3 */
+	"%s: %s used inconsistently (%s)",			      /* 4 */
+	"%s: %s declared inconsistently (%s)",			      /* 5 */
+	"%s: %s arg %d used inconsistently (%s)",		      /* 6 */
+	"%s: %s called with varying # of args (%s)",		      /* 7 */
 	"%s returns value which is always ignored",		      /* 8 */
 	"%s returns value which is sometimes ignored",		      /* 9 */
-	"%s value is used( %s ), but none returned",		      /* 10 */
-	"%s, arg %d declared inconsistently  \t%s :: %s",	      /* 11 */
-	"%s: variable # of args declared  \t%s  ::  %s",	      /* 12 */
-	"%s: malformed format string  \t%s",			      /* 13 */
-	"%s, arg %d inconsistent with format  \t%s",		      /* 14 */
-	"%s: too few args for format  \t%s",			      /* 15 */
-	"%s: too many args for format  \t%s",			      /* 16 */
-	"%s function value must be declared before use  \t%s  ::  %s",/* 17 */
+	"%s: return value of %s is used, but none returned",	      /* 10 */
+	"%s: %s arg %d declared inconsistently (%s)",		      /* 11 */
+	"%s: %s declared with varying # of args (%s)",		      /* 12 */
+	"%s: malformed format string to %s",			      /* 13 */
+	"%s, arg %d to %s inconsistent with format",		      /* 14 */
+	"%s: too few format args to %s",			      /* 15 */
+	"%s: too many format args to %s",			      /* 16 */
+	"%s: %s must be declared before use (%s)",		      /* 17 */
 };
 
-static	const	char *basename(const char *);
+static	const	char *lbasename(const char *);
 
 void
 msg(int n, ...)
@@ -82,7 +82,7 @@
  * Return a pointer to the last component of a path.
  */
 static const char *
-basename(const char *path)
+lbasename(const char *path)
 {
 	const	char *cp, *cp1, *cp2;
 
@@ -120,16 +120,16 @@
 	}
 	qm = !Hflag && posp->p_src != posp->p_isrc;
 
-	len = strlen(fn = basename(fnames[src]));
+	len = strlen(fn = lbasename(fnames[src]));
 	len += 3 * sizeof (u_short) + 4;
 
 	if (len > blen)
 		buf = xrealloc(buf, blen = len);
 	if (line != 0) {
-		(void)sprintf(buf, "%s%s(%hu)",
+		(void)snprintf(buf, blen, "%s%s:%hu",
 			      fn, qm ? "?" : "", line);
 	} else {
-		(void)sprintf(buf, "%s", fn);
+		(void)snprintf(buf, blen, "%s", fn);
 	}
 
 	return (buf);
Index: usr.bin/xlint/lint2/read.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/read.c,v
retrieving revision 1.7
diff -u -r1.7 read.c
--- usr.bin/xlint/lint2/read.c	7 Jul 2004 12:13:26 -0000	1.7
+++ usr.bin/xlint/lint2/read.c	25 Dec 2006 10:40:09 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: read.c,v 1.9 2005/12/01 05:06:40 cloder Exp $	*/
 /*	$NetBSD: read.c,v 1.2 1995/07/03 21:24:59 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: read.c,v 1.2 1995/07/03 21:24:59 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint2/read.c,v 1.7 2004/07/07 12:13:26 asmodai Exp $
  */
 
@@ -78,7 +78,7 @@
 static	size_t	tlstlen;		/* length of tlst */
 
 /* index of current C source file (as spezified at the command line) */
-static	int	csrcfile;
+int	csrcfile;
 
 
 static	void	inperr(void);
@@ -130,7 +130,7 @@
 		/* line number in csrcfile */
 		cline = (int)strtol(cp, &eptr, 10);
 		if (cp == eptr) {
-		        cline = -1;
+			cline = -1;
 		} else {
 			cp = eptr;
 		}
@@ -216,7 +216,7 @@
 
 /*
  * setfnid() gets as input an index as used in an input file and the
- * associated file name. If neccessary, it creates a new lint2 file
+ * associated file name. If necessary, it creates a new lint2 file
  * name index for this file name and creates the mapping of the index
  * as used in the input file to the index used in lint2.
  */
@@ -259,7 +259,7 @@
 	rused = rdisc = 0;
 	lai = &fcall->f_args;
 	while ((c = *cp) == 'u' || c == 'i' || c == 'd' ||
-	       c == 'z' || c == 'p' || c == 'n' || c == 's') {
+	    c == 'z' || c == 'p' || c == 'n' || c == 's') {
 		cp++;
 		switch (c) {
 		case 'u':
@@ -334,8 +334,8 @@
 	used = 0;
 
 	while ((c = *cp) == 't' || c == 'd' || c == 'e' || c == 'u' ||
-	       c == 'r' || c == 'o' || c == 's' || c == 'v' ||
-	       c == 'P' || c == 'S') {
+	    c == 'r' || c == 'o' || c == 's' || c == 'v' ||
+	    c == 'P' || c == 'S') {
 		cp++;
 		switch (c) {
 		case 't':
@@ -601,8 +601,6 @@
 		}
 		break;
 		/* LINTED (enumeration value(s) not handled in switch) */
-	default:
-		break;
 	}
 
 	*epp = cp;
@@ -771,8 +769,6 @@
 		}
 		break;
 		/* LINTED (enumeration value(s) not handled in switch) */
-	default:
-		break;
 	}
 
 	*epp = cp;
@@ -1039,6 +1035,7 @@
 	 */
 	for (nhte = hte; nhte->h_link != NULL; nhte = nhte->h_link) ;
 	nhte->h_link = xalloc(sizeof (hte_t));
+	memset(nhte->h_link, 0, sizeof (hte_t));
 	nhte = nhte->h_link;
 	nhte->h_name = hte->h_name;
 	nhte->h_static = 1;
Index: usr.bin/xlint/llib/llib-lstdc
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/llib/llib-lstdc,v
retrieving revision 1.1
diff -u -r1.1 llib-lstdc
--- usr.bin/xlint/llib/llib-lstdc	17 Jun 2003 02:56:38 -0000	1.1
+++ usr.bin/xlint/llib/llib-lstdc	28 Dec 2006 16:31:50 -0000
@@ -80,7 +80,7 @@
 /*
  * errno.h
  */
-int	(errno);
+/* int	(errno); */
 
 /*
  * locale.h
Index: usr.bin/xlint/xlint/xlint.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/xlint/xlint.c,v
retrieving revision 1.12
diff -u -r1.12 xlint.c
--- usr.bin/xlint/xlint/xlint.c	2 Oct 2006 13:26:40 -0000	1.12
+++ usr.bin/xlint/xlint/xlint.c	25 Dec 2006 11:02:58 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: xlint.c,v 1.32 2006/11/10 00:54:59 deraadt Exp $	*/
 /*	$NetBSD: xlint.c,v 1.3 1995/10/23 14:29:30 jpo Exp $	*/
 
 /*
@@ -91,7 +92,7 @@
 static	char	**libsrchpath;
 
 /* flags */
-static	int	iflag, oflag, Cflag, sflag, tflag, Fflag, Sflag;
+static	int	iflag, oflag, Cflag, sflag, tflag, Fflag = 1;
 
 /* print the commands executed to run the stages of compilation */
 static	int	Vflag;
@@ -108,7 +109,6 @@
  */
 static	const	char *currfn;
 
-
 static	void	appstrg(char ***, char *);
 static	void	appcstrg(char ***, const char *);
 static	void	applst(char ***, char *const *);
@@ -116,11 +116,11 @@
 static	char	*concat2(const char *, const char *);
 static	char	*concat3(const char *, const char *, const char *);
 static	void	terminate(int);
-static	const	char *basename(const char *, int);
+static	const	char *lbasename(const char *, int);
 static	void	appdef(char ***, const char *);
 static	void	usage(void);
-static	void	fname(const char *, int);
-static	void	runchild(const char *, char *const *, const char *);
+static	void	fname(const char *);
+static	int	runchild(const char *, char *const *, const char *);
 static	void	findlibs(char *const *);
 static	int	rdok(const char *);
 static	void	lint2(void);
@@ -128,7 +128,7 @@
 
 /*
  * Some functions to deal with lists of strings.
- * Take care that we get no surprises in case of asyncron signals.
+ * Take care that we get no surprises in case of asynchronous signals.
  */
 static void
 appstrg(char ***lstp, char *s)
@@ -187,10 +187,11 @@
 concat2(const char *s1, const char *s2)
 {
 	char	*s;
+	size_t len = strlen(s1) + strlen(s2) + 1;
 
-	s = xmalloc(strlen(s1) + strlen(s2) + 1);
-	strcpy(s, s1);
-	strcat(s, s2);
+	s = xmalloc(len);
+	strlcpy(s, s1, len);
+	strlcat(s, s2, len);
 
 	return (s);
 }
@@ -199,11 +200,12 @@
 concat3(const char *s1, const char *s2, const char *s3)
 {
 	char	*s;
+	size_t len = strlen(s1) + strlen(s2) + strlen(s3) + 1;
 
-	s = xmalloc(strlen(s1) + strlen(s2) + strlen(s3) + 1);
-	strcpy(s, s1);
-	strcat(s, s2);
-	strcat(s, s3);
+	s = xmalloc(len);
+	strlcpy(s, s1, len);
+	strlcat(s, s2, len);
+	strlcat(s, s3, len);
 
 	return (s);
 }
@@ -230,7 +232,7 @@
 	if (currfn != NULL)
 		remove(currfn);
 
-	exit(signo != 0 ? 1 : 0);
+	_exit(signo != 0 ? 1 : 0);
 }
 
 /*
@@ -238,7 +240,7 @@
  * Returns strg if the string does not contain delim.
  */
 static const char *
-basename(const char *strg, int delim)
+lbasename(const char *strg, int delim)
 {
 	const	char *cp, *cp1, *cp2;
 
@@ -260,20 +262,20 @@
 }
 
 static void
-usage(void)
+usage()
 {
-	printf("lint [-abceghprvxzHFS] [-s|-t] [-i|-nu] [-Dname[=def]] [-Uname]\n");
-	printf("     [-Idirectory] [-Ldirectory] [-llibrary] [-ooutputfile] file ...\n");
-	printf("\n");
-	printf("lint [-abceghprvzHFS] [-s|-t] -Clibrary [-Dname[=def]]\n");
-	printf("     [-Idirectory] [-Uname] file ...\n");
+	printf("usage: lint [-abceghprvxzHF] [-s|-t] [-i|-nu] [-Dname[=def]] [-Uname]\n");
+	printf("            [-Idirectory] [-Ldirectory] [-llibrary] [-ooutputfile] file ...\n");
+	printf("       lint [-abceghprvzHF] [-s|-t] -Clibrary [-Dname[=def]]\n");
+	printf("            [-Idirectory] [-Uname] file ...\n");
 	terminate(-1);
 }
 
 int
-main(int argc, char **argv)
+main(int argc, char *argv[])
 {
-	int	c, fd;
+	int	c;
+	int	fd;
 	char	flgbuf[3], *tmp, *s;
 	size_t	len;
 	struct	utsname un;
@@ -282,20 +284,17 @@
 		tmpdir = xstrdup(_PATH_TMP);
 	} else {
 		s = xmalloc(len + 2);
-		sprintf(s, "%s%s", tmp, tmp[len - 1] == '/' ? "" : "/");
+		snprintf(s, len + 2, "%s%s", tmp, tmp[len - 1] == '/' ? "" : "/");
 		tmpdir = s;
 	}
 
-	cppout = xmalloc(strlen(tmpdir) + sizeof ("lint0.XXXXXX"));
-	sprintf(cppout, "%slint0.XXXXXX", tmpdir);
-
-	fd = mkstemp(cppout);
-	if (fd == -1) {
-		err(1, "could not make a temporary file");
-		close(fd);
+	if (asprintf(&cppout, "%slint0.XXXXXXXXXX", tmpdir) == -1)
+		err(1, NULL);
+	if ((fd = mkstemp(cppout)) == -1) {
+		warn("can't make temp");
 		terminate(-1);
 	}
-	close (fd);
+	close(fd);
 
 	p1out = xcalloc(1, sizeof (char *));
 	p2in = xcalloc(1, sizeof (char *));
@@ -322,18 +321,11 @@
 #endif
 #endif
 	appcstrg(&cppflags, "-Wcomment");
-#ifdef __DragonFly__
-	appcstrg(&cppflags, "-D__DragonFly__=" __XSTRING(__DragonFly__));
-#else
-#	error "This ain't NetBSD.  You lose!"
-	appcstrg(&cppflags, "-D__NetBSD__");
-#endif
+	appcstrg(&cppflags, "-D__DragonFly__");
 	appcstrg(&cppflags, "-Dlint");		/* XXX don't def. with -s */
 	appdef(&cppflags, "lint");
 	appdef(&cppflags, "unix");
 
-	appcstrg(&lcppflgs, "-Wtraditional");
-
 	if (uname(&un) == -1)
 		err(1, "uname");
 	appdef(&cppflags, un.machine);
@@ -355,8 +347,7 @@
 	signal(SIGTERM, terminate);
 
 	while (argc > optind) {
-
-		c = getopt(argc, argv, "abceghil:no:prstuvxzC:D:FHI:L:SU:V");
+		c = getopt(argc, argv, "abcefghil:no:prstuvxyzC:D:FHI:L:U:V");
 
 		switch (c) {
 
@@ -364,11 +355,13 @@
 		case 'b':
 		case 'c':
 		case 'e':
+		case 'f':
 		case 'g':
 		case 'r':
 		case 'v':
+		case 'y':
 		case 'z':
-			sprintf(flgbuf, "-%c", c);
+			snprintf(flgbuf, sizeof flgbuf, "-%c", c);
 			appcstrg(&l1flags, flgbuf);
 			break;
 
@@ -377,7 +370,7 @@
 			/* FALLTHROUGH */
 		case 'u':
 		case 'h':
-			sprintf(flgbuf, "-%c", c);
+			snprintf(flgbuf, sizeof flgbuf, "-%c", c);
 			appcstrg(&l1flags, flgbuf);
 			appcstrg(&l2flags, flgbuf);
 			break;
@@ -414,21 +407,13 @@
 			sflag = 1;
 			break;
 
-		case 'S':
-			if (tflag)
-				usage();
-			appcstrg(&l1flags, "-S");
-			Sflag = 1;
-
 		case 't':
 			if (sflag)
 				usage();
 			freelst(&lcppflgs);
 			appcstrg(&lcppflgs, "-traditional");
 			appstrg(&lcppflgs, concat2("-D", MACHINE));
-#ifdef MACHINE_ARCH
 			appstrg(&lcppflgs, concat2("-D", MACHINE_ARCH));
-#endif
 			appcstrg(&l1flags, "-t");
 			appcstrg(&l2flags, "-t");
 			tflag = 1;
@@ -443,15 +428,15 @@
 				usage();
 			Cflag = 1;
 			appstrg(&l2flags, concat2("-C", optarg));
-			p2out = xmalloc(sizeof ("llib-l.ln") + strlen(optarg));
-			sprintf(p2out, "llib-l%s.ln", optarg);
+			if (asprintf(&p2out, "llib-l%s.ln", optarg) == -1)
+				err(1, NULL);
 			freelst(&deflibs);
 			break;
 
 		case 'D':
 		case 'I':
 		case 'U':
-			sprintf(flgbuf, "-%c", c);
+			snprintf(flgbuf, sizeof flgbuf, "-%c", c);
 			appstrg(&cppflags, concat2(flgbuf, optarg));
 			break;
 
@@ -484,14 +469,15 @@
 
 		case -1:
 			/* filename */
-			fname(argv[optind], argc == optind + 1);
+			if (argv[optind] == NULL)
+				break;
+			fname(argv[optind++]);
 			first = 0;
-
-			argc -= optind;
-			argv += optind;
-			optreset = optind = 1;
 		}
+
 	}
+	argc -= optind;
+	argv += optind;
 
 	if (first)
 		usage();
@@ -518,7 +504,6 @@
 
 	terminate(0);
 	/* NOTREACHED */
-	return 0;
 }
 
 /*
@@ -526,15 +511,16 @@
  * and pass it through lint1 if it is a C source.
  */
 static void
-fname(const char *name, int last)
+fname(const char *name)
 {
 	const	char *bn, *suff;
 	char	**args, *ofn, *path;
 	size_t	len;
-	int fd;
+	int	error;
+	int	fd;
 
-	bn = basename(name, '/');
-	suff = basename(bn, '.');
+	bn = lbasename(name, '/');
+	suff = lbasename(bn, '.');
 
 	if (strcmp(suff, "ln") == 0) {
 		/* only for lint2 */
@@ -545,33 +531,29 @@
 
 	if (strcmp(suff, "c") != 0 &&
 	    (strncmp(bn, "llib-l", 6) != 0 || bn != suff)) {
-		warnx("unknown file type: %s\n", name);
+		warnx("unknown file type: %s", name);
 		return;
 	}
 
-	if (!iflag || !first || !last)
-		printf("%s:\n", Fflag ? name : bn);
-
 	/* build the name of the output file of lint1 */
 	if (oflag) {
 		ofn = outputfn;
 		outputfn = NULL;
 		oflag = 0;
 	} else if (iflag) {
-		ofn = xmalloc(strlen(bn) + (bn == suff ? 4 : 2));
-		len = bn == suff ? strlen(bn) : (suff - 1) - bn;
-		sprintf(ofn, "%.*s", (int)len, bn);
-		strcat(ofn, ".ln");
+		len = strlen(bn) + (bn == suff ? 4 : 2);
+		ofn = xmalloc(len);
+		snprintf(ofn, len, "%.*s",
+		    bn == suff ? strlen(bn) : (suff - 1) - bn, bn);
+		strlcat(ofn, ".ln", len);
 	} else {
-		ofn = xmalloc(strlen(tmpdir) + sizeof ("lint1.XXXXXX"));
-		sprintf(ofn, "%slint1.XXXXXX", tmpdir);
-		fd = mkstemp(ofn);
-		if (fd == -1) {
-			err(1, "could not make a temporary file");
-			close(fd);
+		if (asprintf(&ofn, "%slint1.XXXXXXXXXX", tmpdir) == -1)
+			err(1, NULL);
+		if ((fd  = mkstemp(ofn)) == -1) {
+			warn("can't make temp");
 			terminate(-1);
-        	}
-        	close (fd);
+		}
+		close(fd);
 	}
 	if (!iflag)
 		appcstrg(&p1out, ofn);
@@ -580,8 +562,8 @@
 
 	/* run cpp */
 
-	path = xmalloc(strlen(PATH_USRBIN) + sizeof ("/cpp"));
-	sprintf(path, "%s/cpp", PATH_USRBIN);
+	if (asprintf(&path, "%s/cpp", PATH_USRBIN) == -1)
+		err(1, NULL);
 
 	appcstrg(&args, path);
 	applst(&args, cppflags);
@@ -589,23 +571,27 @@
 	appcstrg(&args, name);
 	appcstrg(&args, cppout);
 
-	runchild(path, args, cppout);
+	error = runchild(path, args, cppout);
 	free(path);
 	freelst(&args);
+	if (error)
+		return;
 
 	/* run lint1 */
 
-	path = xmalloc(strlen(PATH_LIBEXEC) + sizeof ("/lint1"));
-	sprintf(path, "%s/lint1", PATH_LIBEXEC);
+	if (asprintf(&path, "%s/lint1", PATH_LIBEXEC) == -1)
+		err(1, NULL);
 
 	appcstrg(&args, path);
 	applst(&args, l1flags);
 	appcstrg(&args, cppout);
 	appcstrg(&args, ofn);
 
-	runchild(path, args, ofn);
+	error = runchild(path, args, ofn);
 	free(path);
 	freelst(&args);
+	if (error)
+		return;
 
 	appcstrg(&p2in, ofn);
 	free(ofn);
@@ -613,10 +599,11 @@
 	free(args);
 }
 
-static void
+static int
 runchild(const char *path, char *const *args, const char *crfn)
 {
-	int	status, rv, signo, i;
+	int	status, signo, i;
+	pid_t	rv;
 
 	if (Vflag) {
 		for (i = 0; args[i] != NULL; i++)
@@ -643,20 +630,21 @@
 		exit(1);
 		/* NOTREACHED */
 	}
+	currfn = NULL;
 
 	while ((rv = wait(&status)) == -1 && errno == EINTR) ;
 	if (rv == -1) {
 		warn("wait");
-		terminate(-1);
+		return(-1);
 	}
 	if (WIFSIGNALED(status)) {
 		signo = WTERMSIG(status);
 		warnx("%s got SIG%s", path, sys_signame[signo]);
-		terminate(-1);
+		return(-1);
 	}
 	if (WEXITSTATUS(status) != 0)
-		terminate(-1);
-	currfn = NULL;
+		return(-1);
+	return(0);
 }
 
 static void
@@ -665,19 +653,21 @@
 	int	i, k;
 	const	char *lib, *path;
 	char	*lfn;
-	size_t	len;
+	size_t	len, l;
 
 	lfn = NULL;
 
 	for (i = 0; (lib = liblst[i]) != NULL; i++) {
 		for (k = 0; (path = libsrchpath[k]) != NULL; k++) {
 			len = strlen(path) + strlen(lib);
-			lfn = xrealloc(lfn, len + sizeof ("/llib-l.ln"));
-			sprintf(lfn, "%s/llib-l%s.ln", path, lib);
+			l = len + sizeof ("/llib-l.ln");
+			lfn = xrealloc(lfn, l);
+			snprintf(lfn, l, "%s/llib-l%s.ln", path, lib);
 			if (rdok(lfn))
 				break;
-			lfn = xrealloc(lfn, len + sizeof ("/lint/llib-l.ln"));
-			sprintf(lfn, "%s/lint/llib-l%s.ln", path, lib);
+			l = len + sizeof ("/lint/llib-l.ln");
+			lfn = xrealloc(lfn, l);
+			snprintf(lfn, l, "%s/lint/llib-l%s.ln", path, lib);
 			if (rdok(lfn))
 				break;
 		}
@@ -706,14 +696,14 @@
 }
 
 static void
-lint2(void)
+lint2()
 {
 	char	*path, **args;
 
 	args = xcalloc(1, sizeof (char *));
 
-	path = xmalloc(strlen(PATH_LIBEXEC) + sizeof ("/lint2"));
-	sprintf(path, "%s/lint2", PATH_LIBEXEC);
+	if (asprintf(&path, "%s/lint2", PATH_LIBEXEC) == -1)
+		err(1, NULL);
 
 	appcstrg(&args, path);
 	applst(&args, l2flags);
